@article{Beudaert2011,
author = {Beudaert, Xavier and Pechard, Pierre-Yves and Tournier, Christophe},
file = {:home/tim/Dropbox/EigenDocumenten/Doctoraat/Publications/TimMercy{\_}2017{\_}CNC/Bibliography/5-Axis tool path smoothing based on drive constraints.pdf:pdf},
journal = {International Journal of Machine Tools and Manufacture},
keywords = {5-axis machining,drive constraints,machine tool kinematic,tool path smoothing},
number = {12},
pages = {958--965},
title = {{5-Axis Tool Path Smoothing Based on Drive Constraints}},
volume = {51},
year = {2011}
}

@book{deBoor1978,
address = {New York},
author = {de Boor, Carl},
pages = {87--91},
publisher = {Springer-Verlag},
title = {{A Practical Guide to Splines}},
year = {1978}
}

@phdthesis{Sellmann2014,
author = {Sellmann, Florian},
doi = {10.3929/ethz-a-010782581},
file = {:home/tim/Dropbox/EigenDocumenten/Doctoraat/Publications/TimMercy{\_}2017{\_}CNC/Bibliography/Sellmann{\_}thesis{\_}inspire{\_}eth-47096-02.pdf:pdf},
isbn = {8610828378018},
pages = {12--19},
school = {ETH Z{\"{u}}rich},
title = {{Exploitation of tolerances and quasi-redundancy for set point generation}},
year = {2014}
}

@article{Bosetti2014,
abstract = {The key task performed by CNCs is the generation of the time-sequence of set-points for driving each physical axis of the machine tool during program execution. This interpolation of axes movement must satisfy a number of constraints on axes dynamics (velocity, acceleration, and jerk), and on process outcome (smooth tool movement and precise tracking of the nominal tool-path at the desired feed-rate). This paper presents an algorithm for CNC kernels that aims at solving the axes interpolation problem by exploiting an Optimal Control Problem formulation. With respect to other solutions proposed in the literature, the approach presented here takes an original approach by assuming a predefined path tracking tolerance - to be added to the constraints listed above - and calculating the whole trajectory (path and feed-rate profile) that satisfies the given constraints. The effectiveness of the proposed solution is benchmarked against the trajectory generated by an industrial, state-of-the-art CNC, proving a significant advantage in efficiency and smoothness of axes velocity profiles. {\textcopyright} 2014 Elsevier Ltd.},
author = {Bosetti, Paolo and Bertolazzi, Enrico},
doi = {10.1016/j.rcim.2014.03.009},
file = {:home/tim/Dropbox/EigenDocumenten/Doctoraat/Publications/TimMercy{\_}2017{\_}CNC/Bibliography/feedrate and trajectory optimization for cnc machine tools.pdf:pdf},
isbn = {0736-5845},
issn = {07365845},
journal = {Robotics and Computer-Integrated Manufacturing},
keywords = {CNC controller,Feed-rate optimization,Manufacturing,Optimal control,Trajectory planning},
number = {6},
pages = {667--677},
publisher = {Elsevier},
title = {{Feed-rate and trajectory optimization for CNC machine tools}},
url = {http://dx.doi.org/10.1016/j.rcim.2014.03.009},
volume = {30},
year = {2014}
}

@article{Altintas2003,
abstract = {A feedrate optimization technique has been developed for minimizing the cycle time in machining spline toolpaths. Axis velocity, torque and jerk limits are considered throughout the motion in order to ensure smooth and linear operation of the servo drives with minimal tracking error. Feed modulation is achieved by manipulating segment durations which define the overall minimum jerk feed profile. Long toolpaths are handled by applying a windowing technique. The optimized feed profile allows nonzero acceleration and jerk values at segment connections, resulting in continuous and smooth motion within the velocity, torque, and jerk limits of the drives. The cycle time reduction obtained with the proposed technique is demonstrated in high speed contouring experiments.},
author = {Altintas, Y and Erkorkmaz, K},
doi = {10.1016/S0007-8506(07)60588-5},
file = {:home/tim/Dropbox/EigenDocumenten/Doctoraat/Publications/TimMercy{\_}2017{\_}CNC/Bibliography/feedrate optimization for spline interpolation in high speed machine tools.pdf:pdf},
isbn = {0007-8506},
issn = {00078506},
journal = {CIRP Annals - Manufacturing Technology},
keywords = {CNC,Interpolator,Spline},
number = {1},
pages = {297--302},
title = {{Feedrate Optimization for Spline Interpolation In High Speed Machine Tools}},
url = {http://www.sciencedirect.com/science/article/B8CXH-4P37B1V-2K/2/b826b3b2d2f2bcc28b010aa1d90744cc},
volume = {52},
year = {2003}
}
@phdthesis{Steinlin2013,
abstract = {Productivity of a machine tool can be significantly influenced by the dynamic of the axes. The dynamic of the axes is maximized under the condition that the product results in the required quality. The properties of the machine tool structure, the drive chain and the process define the boundary conditions for the maximization of the productivity. Due to the dependences of the dynamic properties these boundary conditions cannot be reached permanently. A feed-rate optimization algorithm minimizes the process time (by maximizing the veloc- ity) for a given geometry (decoupled approach) while respecting the boundary conditions determined by the machine's properties. This thesis presents a new feed-rate optimization algorithm which determines velocity, acceleration, force, jerk and jerk-rate limited trajectories. All limitations are realized using a physical description of the limitation at every position along the trajectory. The algorithm uses a direct method and formulates a discrete minimum time optimal control problem which can be solved with a standard solver for optimization problems. Optimal trajectories generated with the feed-rate optimization algorithm are demonstrated. Dynamic deviations in orthogonal direction to the moving direction (cross-talk) can be compensated by a measurement- and model-based method. It is demonstrated that this compensation method reduces the (lateral) path deviation by a factor two while maintain- ing the same productivity. This thesis further presents two trajectory generation algorithms for under-determined kinematic systems. The first approach is a novel optimal algorithm which separates a given trajectory at the tool center point (TCP) into two trajectories for two serially arranged linear subsystems. The separation is such that the excitation of the machine is minimized. The second approach determines the trajectories for the subsystems from a discrete mini- mum time optimal control problem. The formulation is based on axis-wise limitations of the under-determined kinematic system. This thesis shows that feed-rate optimization with limitations based on a physical model of a machine tool is viable at least for limitations up to the 4th derivative of the position with respect to time. Further, it is proven that this approach is also viable for under-determined kinematics systems.},
author = {Steinlin, M.},
doi = {10.3929/ethz-a-009921073},
file = {:home/tim/Dropbox/EigenDocumenten/Doctoraat/Publications/TimMercy{\_}2017{\_}CNC/Bibliography/Steinlin{\_}thesis{\_}inspire{\_}eth-7239-02.pdf:pdf},
number = {20746},
school = {ETH Z{\"{u}}rich},
title = {{Model based Feed-rate Optimization for Machine Tool Trajectories}},
url = {http://e-collection.library.ethz.ch/eserv/eth:7239/eth-7239-02.pdf},
year = {2013}
}

@article{Zhang2012,
abstract = {An optimization approach is proposed in this paper for generating smooth and time-optimal path constrained tool trajectory for Cartesian computer numerical control (CNC) manufacturing systems. The desired smooth time-optimal trajectory generation (STOTG) problem is formulated as a general optimal control problem. And axis jerk (derivative of acceleration with respect to time) constraints are introduced into this problem to remove discontinuities of the acceleration profiles. The desired smoothness of the trajectory can be accomplished by adjusting the values of jerk constraints. A control vector parameterization (CVP) method is applied to convert the optimal control problem into a nonlinear programming (NLP) problem which can be solved conveniently and effectively. The third derivative of the path parameter with respect to time (pseudo-jerk) and jerk act as optimization variables. The pseudo-jerk is approximated as piecewise constant, thus for at least second-order continuous parametric path, the resulted optimized trajectory with respect to time is also at least second-order continuous. Sequential quadratic programming (SQP) method is used to solve the NLP problem, through which numerical solution is obtained. Non-smooth (i.e. without considering jerk constraints) time-optimal trajectory generation (non-STOTG) problem is also considered in this paper for the purpose of comparison. Solutions of time-optimal trajectory generation (TOTG) problems for two test paths are performed to verify the effectiveness of the proposed approach. {\textcopyright} 2012 The Society of Manufacturing Engineers.},
author = {Zhang, Qiang and Li, Shurong and Guo, Jianxin},
doi = {10.1016/j.jmsy.2012.06.001},
file = {:home/tim/Dropbox/EigenDocumenten/Doctoraat/Publications/TimMercy{\_}2017{\_}CNC/Bibliography/Smooth time-optimal tool trajectory generation for cnc manufacturing systems.pdf:pdf},
isbn = {0278-6125},
issn = {02786125},
journal = {Journal of Manufacturing Systems},
keywords = {CNC,Jerk constraint,Manufacturing systems,Smooth trajectory,Time optimal},
number = {3},
pages = {280--287},
publisher = {The Society of Manufacturing Engineers},
title = {{Smooth time-optimal tool trajectory generation for CNC manufacturing systems}},
url = {http://dx.doi.org/10.1016/j.jmsy.2012.06.001},
volume = {31},
year = {2012}
}
@article{Verscheure2009,
abstract = {See, stats, and : https : / / www . researchgate . net / publication / 229036395 Practical - optimal robots : a ARTICLE Impact : 2 . 78 CITATIONS 3 READS 246 5 , INCLUDING : Diederik NV 13 SEE Bram 64 SEE Jan University 264 , 613 SEE Moritz University 250 , 917 SEE Available : Moritz Retrieved : 30 Abstract—This paper focuses on time - optimal path - constrained trajectory planning , a subproblem in time - optimal motion plan - ning of robot systems . Through a nonlinear change of variables , the time - optimal trajectory planning is transformed here into a convex optimal control problem with a single state . Various convexity - preserving extensions are introduced , resulting in a versatile approach for optimal trajectory planning . A direct tran - scription method is presented that reduces finding the globally optimal trajectory to solving a second - order cone program using robust numerical algorithms that are freely available . Validation against known examples and application to a more complex example illustrate the versatility and practicality of the new method .},
author = {Verscheure, Diederik and Demeulenaere, Bram and Swevers, Jan and {De Schutter}, Joris and Diehl, Moritz},
doi = {10.1109/TAC.2009.2028959},
file = {:home/tim/Dropbox/EigenDocumenten/Doctoraat/Publications/TimMercy{\_}2017{\_}CNC/Bibliography/Time-optimal path tracking for robots - a convex optimization approach.pdf:pdf},
isbn = {978-1-4244-1702-5},
issn = {00189286},
journal = {IEEE Transactions on Automatic Control},
keywords = {Second-order cone program (SOCP)-based solution me},
number = {10},
pages = {2318--2327},
title = {{Time-optimal path tracking for robots: A convex optimization approach}},
volume = {54},
year = {2009}
}

@article{Erkorkmaz2017,
author = {Erkorkmaz, K. and Chen, Q.-G. and Zhao, M.-Y. and Beudaert, X.},
journal = {CIRP Annals - Manufacturing Technology},
number = {66},
pages = {393--396},
title = {{Linear Programming and Windowing based Feedrate Optimization for Spline Toolpaths}},
year = {2017}
}

@article{Schorderet2019,
author = {Schorderet, A. and Herzog, R. and Jacquot, N. and Marchand, Y. and Prongue, Ch.},
journal = {Modern Machinery (MM) Science Journal},
pages = {3179--3186},
title = {{Productivity Increase of High Precision Micro-Milling by Trajectory Optimization}},
year = {2019}
}

@article{Herzog2019,
author = {Herzog, R. and Blanc, Ph.},
journal = {Computer-Aided Design, Elsevier},
doi = {10.1016/j.cad.2019.102752},
url     = {https://www.sciencedirect.com/science/article/pii/S0010448518304305},
volume = {117},
title = {{Optimal G^2 Hermite Interpolation for 3D Curves}},
year = {2019}
}

@article{Mercy2019,
author = {Mercy, T. and Jacquod, N. and Herzog, R. and Pipeleers, G.},
journal = {IEEE Transactions on Industrial Electronics},
doi = {10.1109/TIE.2018.2874617},
volume = {66},
title = {{Spline-Based Trajectory Generation for CNC Machines}},
year = {2019}
}

@article{Stellato2020,
  author  = {Stellato, B. and Banjac, G. and Goulart, P. and Bemporad, A. and Boyd, S.},
  title   = {{OSQP}: an operator splitting solver for quadratic programs},
  journal = {Mathematical Programming Computation},
  volume  = {12},
  number  = {4},
  pages   = {637--672},
  year    = {2020},
  doi     = {10.1007/s12532-020-00179-2},
  url     = {https://doi.org/10.1007/s12532-020-00179-2},
}

@article{Lee1989,
  author  = {Lee, E.T.Y.},
  title   = {Choosing nodes in parametric curve interpolation},
  journal = {Computer-Aided Design},
  volume  = {21},
   pages   = {363--370},
  year    = {1989},
}
